#include "Interfaz.h"
#include "GestorRanking.h"
#include <iostream>
#include <list>
#include <sstream>

using namespace std;

Interfaz::Estados Interfaz::estado = MenuPrincipal;
int Interfaz::accion = 0;
int Interfaz::minutos = 1;
bool Interfaz::tiempo = false;

Interfaz::Interfaz()
{
	
}

void Interfaz::mostrarYElegir()
{
	string input="";
	int opcion;
	if (estado==MenuPrincipal)
	{
		cout <<endl<<"BRAIN TRAINING louis87"<<endl<<endl;
		cout <<"Selecciona una opción y pulsa enter"<<endl;
		cout <<"\t1. Nueva partida"<<endl;
		cout <<"\t2. Opciones"<<endl;
		cout <<"\t3. Ranking"<<endl;
		cout <<"\t4. Salir"<<endl<<endl;
		cout <<"Opcion: ";
		getline(cin,input);
		stringstream myStream(input);
		if (myStream >> opcion)
		{
			if (opcion>=1 && opcion<=4)
			{
				setOpcion(opcion);
			}
			else
			{
				cout <<"ERROR, Opcion incorrecta"<<endl;
			}
		}
		else
		{
			cout <<"ERROR, Debes introducir un numero"<<endl;
		}
	}
	else if (estado==Opciones)
	{	
		cout <<endl<<endl<<"Opciones"<<endl;
		cout <<"\t1. Establecer duración juego"<<endl;
		cout <<"\t2. Mostrar tiempo restante en cada pregunta ";
		if (tiempo)	cout<<"(Activado)"<<endl;
		else		cout<<"(Desactivado)"<<endl;
		cout <<"\t3. Volver"<<endl<<endl;
		cout <<"Opcion: ";
		getline(cin,input);
		stringstream myStream(input);
		if (myStream >> opcion)
		{
			if (opcion>=1 && opcion<=3)
			{
				setOpcion(opcion);
			}
			else
			{
				cout <<"Opcion incorrecta"<<endl;
			}
		}
		else
		{
			cout <<"ERROR, Debes introducir un numero"<<endl;
		}
	}
	else if (estado==Ranking)
	{
		list<Puntuacion> ranking;
		GestorRanking::getRanking(ranking);

		list<Puntuacion>::iterator it = ranking.begin();

		cout <<endl<<"RANKING"<<endl;
		while( it != ranking.end() )
		{
		  	cout <<(*it).nombre;

			for (int i=20 - (*it).nombre.length(); i>0; i--)
				cout <<" ";

			cout<<(*it).puntos<<endl;

			

			*it++;
		}
		
		cout <<endl<<"Pulsa intro para volver";
		cin.get();
		estado=MenuPrincipal;
	}
}

void Interfaz::setOpcion(int n)
{
	string input="";
	if (estado==MenuPrincipal)
	{
		if (n==1)
		{
			estado=MenuPrincipal;
			accion=1;	//jugar
		}
		else if (n==2)
		{
			estado=Opciones;
			accion=0;	//nada
		}
		else if (n==3)
		{
			estado=Ranking;
			accion=0;	//nada
		}
		else if (n==4)
		{
			accion=-1;	//salir
		}
	}
	else if (estado==Opciones)
	{
		if (n==1)
		{
			int minutosTemp=minutos;
			estado=Opciones;
			accion=0;	//jugar
			cout<<"Introduce los minutos (entre 1 y 3): ";
			getline(cin,input);
			stringstream myStream(input);
			if (myStream >> minutos)
			{
				if (minutos<1 || minutos>3)
				{
					cout<<"ERROR Los minutos deben estar entre 1 y 3 "<<endl;
					minutos=minutosTemp;
				}
			}
			else
			{
				cout <<"ERROR, Debes introducir un numero"<<endl;
				minutos=minutosTemp;
			}
		}
		else if (n==2)
		{
			estado=Opciones;
			tiempo=!tiempo;
			accion=0;	//nada
		}
		else if (n==3)
		{
			estado=MenuPrincipal;
			accion=0;	//nada
		}
	}
}

int Interfaz::getAccion()
{
	int accionTemp = accion;
	if (accion==1)	accion=0;
	return accionTemp;
}

int Interfaz::getMinutos()
{
	return minutos;
}

bool Interfaz::getSiTiempo()
{
	return tiempo;
}
