#ifndef INTERFAZ_H
#define INTERFAZ_H

//Representa la interfaz (menú)
class Interfaz
{
	//estados posibles de la interfaz
	enum Estados
	{
		MenuPrincipal,
		Opciones,
		Ranking,
	};

	public:
		//muestra la interfaz según el estado y coje la entrada del usuario
		static void mostrarYElegir();	
		//devuelve la acción a realizar (0 - sigue en la interfaz, 1 - empieza el juego, 2 - salir)
		static int getAccion();
		//devuelve los minutos de juego especificados en el menú de opciones
		static int getMinutos();
		//devuelve si se muestra el tiempo, según se haya especificado en el menú de opciones
		static bool getSiTiempo();

	private:
		//Constructor privado
		Interfaz();
		//establece la opción a realizar según la entrada
		static void setOpcion(int n);
		//estado en el que se encuentra la interfaz
		static Estados estado;
		//acción a realizar
		static int accion;
		//minutos que durará la partida, definido en el menú de opciones
		static int minutos;
		//si se muestra o no el tiempo restante en cada pregunta, definido en el menú de opciones
		static bool tiempo;
};

#endif
